> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.ishushka.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.ishushka.com/_mcp/server.

# Chat completions

POST https://api.ishushka.com/v1/chat/completions
Content-Type: application/json

OpenAI-compatible chat completions endpoint. Supports streaming via stream=true.

Reference: https://docs.ishushka.com/ishushka-api-actual/open-ai-compatible/openai-chat-completions

## Authentication

- `Authorization` header (bearer token, required) — API key passed as Authorization: Bearer token.

## Request

### Body (application/json)

- `model` (string, required)
- `messages` (list of object, required)
  - `role` (string, optional)
  - `content` (string, optional)
  - `tool_call_id` (string, optional)
  - `name` (string, optional)
- `stream` (boolean, optional, default: false)
- `temperature` (double, optional, default: 0.7)
- `max_tokens` (integer, optional)
- `top_p` (double, optional)
- `frequency_penalty` (double, optional)
- `presence_penalty` (double, optional)

## Response

### 200

Completion or SSE stream

- `id` (string, optional)
- `object` (string, optional)
- `created` (integer, optional)
- `model` (string, optional)
- `choices` (list of object, optional)
- `usage` (object, optional)
  - `prompt_tokens` (integer, optional)
  - `completion_tokens` (integer, optional)
  - `total_tokens` (integer, optional)

## Examples

**Request**

```json
{
  "model": "string",
  "messages": [
    {}
  ]
}
```

**Response**

```json
{
  "id": "string",
  "object": "string",
  "created": 1,
  "model": "string",
  "choices": [
    {}
  ],
  "usage": {
    "prompt_tokens": 1,
    "completion_tokens": 1,
    "total_tokens": 1
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.ishushka.com/v1/chat/completions"

payload = {
    "model": "string",
    "messages": [{}]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.ishushka.com/v1/chat/completions';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"model":"string","messages":[{}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.ishushka.com/v1/chat/completions"

	payload := strings.NewReader("{\n  \"model\": \"string\",\n  \"messages\": [\n    {}\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.ishushka.com/v1/chat/completions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"model\": \"string\",\n  \"messages\": [\n    {}\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.ishushka.com/v1/chat/completions")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"model\": \"string\",\n  \"messages\": [\n    {}\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.ishushka.com/v1/chat/completions', [
  'body' => '{
  "model": "string",
  "messages": [
    {}
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.ishushka.com/v1/chat/completions");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"model\": \"string\",\n  \"messages\": [\n    {}\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "model": "string",
  "messages": [[]]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.ishushka.com/v1/chat/completions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```